##
# This code was generated by
# \ / _    _  _|   _  _
#  | (_)\/(_)(_|\/| |(/_  v1.0.0
#       /       /
#
# frozen_string_literal: true

module Twilio
  module REST
    class Accounts < Domain
      ##
      # Initialize the Accounts Domain
      def initialize(twilio)
        super

        @base_url = 'https://accounts.twilio.com'
        @host = 'accounts.twilio.com'
        @port = 443

        # Versions
        @v1 = nil
      end

      ##
      # Version v1 of accounts
      def v1
        @v1 ||= V1.new self
      end

      ##
      # @return [Twilio::REST::Accounts::V1::AuthTokenPromotionInstance]
      def auth_token_promotion
        self.v1.auth_token_promotion()
      end

      ##
      # @return [Twilio::REST::Accounts::V1::CredentialInstance]
      def credentials
        self.v1.credentials()
      end

      ##
      # @return [Twilio::REST::Accounts::V1::SecondaryAuthTokenInstance]
      def secondary_auth_token
        self.v1.secondary_auth_token()
      end

      ##
      # Provide a user friendly representation
      def to_s
        '#<Twilio::REST::Accounts>'
      end
    end
  end
end