##
# This code was generated by
# \ / _    _  _|   _  _
#  | (_)\/(_)(_|\/| |(/_  v1.0.0
#       /       /
#
# frozen_string_literal: true

module Twilio
  module REST
    class Autopilot
      class V1 < Version
        ##
        # Initialize the V1 version of Autopilot
        def initialize(domain)
          super
          @version = 'v1'
          @assistants = nil
          @restore_assistant = nil
        end

        ##
        # @param [String] sid The Twilio-provided string that uniquely identifies the
        #   Assistant resource to fetch.
        # @return [Twilio::REST::Autopilot::V1::AssistantContext] if sid was passed.
        # @return [Twilio::REST::Autopilot::V1::AssistantList]
        def assistants(sid=:unset)
          if sid.nil?
              raise ArgumentError, 'sid cannot be nil'
          end
          if sid == :unset
              @assistants ||= AssistantList.new self
          else
              AssistantContext.new(self, sid)
          end
        end

        ##
        # @return [Twilio::REST::Autopilot::V1::RestoreAssistantContext]
        def restore_assistant
          @restore_assistant ||= RestoreAssistantList.new self
        end

        ##
        # Provide a user friendly representation
        def to_s
          '<Twilio::REST::Autopilot::V1>'
        end
      end
    end
  end
end