##
# This code was generated by
# \ / _    _  _|   _  _
#  | (_)\/(_)(_|\/| |(/_  v1.0.0
#       /       /
#
# frozen_string_literal: true

module Twilio
  module REST
    class Bulkexports < Domain
      ##
      # Initialize the Bulkexports Domain
      def initialize(twilio)
        super

        @base_url = 'https://bulkexports.twilio.com'
        @host = 'bulkexports.twilio.com'
        @port = 443

        # Versions
        @v1 = nil
      end

      ##
      # Version v1 of bulkexports
      def v1
        @v1 ||= V1.new self
      end

      ##
      # @param [String] resource_type The type of communication – Messages, Calls,
      #   Conferences, and Participants
      # @return [Twilio::REST::Bulkexports::V1::ExportInstance] if resource_type was passed.
      # @return [Twilio::REST::Bulkexports::V1::ExportList]
      def exports(resource_type=:unset)
        self.v1.exports(resource_type)
      end

      ##
      # @param [String] resource_type The type of communication – Messages, Calls,
      #   Conferences, and Participants
      # @return [Twilio::REST::Bulkexports::V1::ExportConfigurationInstance] if resource_type was passed.
      # @return [Twilio::REST::Bulkexports::V1::ExportConfigurationList]
      def export_configuration(resource_type=:unset)
        self.v1.export_configuration(resource_type)
      end

      ##
      # Provide a user friendly representation
      def to_s
        '#<Twilio::REST::Bulkexports>'
      end
    end
  end
end