##
# This code was generated by
# \ / _    _  _|   _  _
#  | (_)\/(_)(_|\/| |(/_  v1.0.0
#       /       /
#
# frozen_string_literal: true

module Twilio
  module REST
    class Bulkexports
      class V1 < Version
        ##
        # Initialize the V1 version of Bulkexports
        def initialize(domain)
          super
          @version = 'v1'
          @exports = nil
          @export_configuration = nil
        end

        ##
        # @param [String] resource_type The type of communication – Messages, Calls,
        #   Conferences, and Participants
        # @return [Twilio::REST::Bulkexports::V1::ExportContext] if resource_type was passed.
        # @return [Twilio::REST::Bulkexports::V1::ExportList]
        def exports(resource_type=:unset)
          if resource_type.nil?
              raise ArgumentError, 'resource_type cannot be nil'
          end
          if resource_type == :unset
              @exports ||= ExportList.new self
          else
              ExportContext.new(self, resource_type)
          end
        end

        ##
        # @param [String] resource_type The type of communication – Messages, Calls,
        #   Conferences, and Participants
        # @return [Twilio::REST::Bulkexports::V1::ExportConfigurationContext] if resource_type was passed.
        # @return [Twilio::REST::Bulkexports::V1::ExportConfigurationList]
        def export_configuration(resource_type=:unset)
          if resource_type.nil?
              raise ArgumentError, 'resource_type cannot be nil'
          end
          if resource_type == :unset
              @export_configuration ||= ExportConfigurationList.new self
          else
              ExportConfigurationContext.new(self, resource_type)
          end
        end

        ##
        # Provide a user friendly representation
        def to_s
          '<Twilio::REST::Bulkexports::V1>'
        end
      end
    end
  end
end