##
# This code was generated by
# \ / _    _  _|   _  _
#  | (_)\/(_)(_|\/| |(/_  v1.0.0
#       /       /
#
# frozen_string_literal: true

module Twilio
  module REST
    class Events < Domain
      class V1 < Version
        class SinkContext < InstanceContext
          ##
          # PLEASE NOTE that this class contains beta products that are subject to change. Use them with caution.
          class SinkTestList < ListResource
            ##
            # Initialize the SinkTestList
            # @param [Version] version Version that contains the resource
            # @param [String] sid A 34 character string that uniquely identifies this Sink.
            # @return [SinkTestList] SinkTestList
            def initialize(version, sid: nil)
              super(version)

              # Path Solution
              @solution = {sid: sid}
              @uri = "/Sinks/#{@solution[:sid]}/Test"
            end

            ##
            # Create the SinkTestInstance
            # @return [SinkTestInstance] Created SinkTestInstance
            def create
              payload = @version.create('POST', @uri)

              SinkTestInstance.new(@version, payload, sid: @solution[:sid], )
            end

            ##
            # Provide a user friendly representation
            def to_s
              '#<Twilio.Events.V1.SinkTestList>'
            end
          end

          ##
          # PLEASE NOTE that this class contains beta products that are subject to change. Use them with caution.
          class SinkTestPage < Page
            ##
            # Initialize the SinkTestPage
            # @param [Version] version Version that contains the resource
            # @param [Response] response Response from the API
            # @param [Hash] solution Path solution for the resource
            # @return [SinkTestPage] SinkTestPage
            def initialize(version, response, solution)
              super(version, response)

              # Path Solution
              @solution = solution
            end

            ##
            # Build an instance of SinkTestInstance
            # @param [Hash] payload Payload response from the API
            # @return [SinkTestInstance] SinkTestInstance
            def get_instance(payload)
              SinkTestInstance.new(@version, payload, sid: @solution[:sid], )
            end

            ##
            # Provide a user friendly representation
            def to_s
              '<Twilio.Events.V1.SinkTestPage>'
            end
          end

          ##
          # PLEASE NOTE that this class contains beta products that are subject to change. Use them with caution.
          class SinkTestInstance < InstanceResource
            ##
            # Initialize the SinkTestInstance
            # @param [Version] version Version that contains the resource
            # @param [Hash] payload payload that contains response from Twilio
            # @param [String] sid A 34 character string that uniquely identifies this Sink.
            # @return [SinkTestInstance] SinkTestInstance
            def initialize(version, payload, sid: nil)
              super(version)

              # Marshaled Properties
              @properties = {'result' => payload['result'], }
            end

            ##
            # @return [String] Feedback indicating whether the test event was generated.
            def result
              @properties['result']
            end

            ##
            # Provide a user friendly representation
            def to_s
              "<Twilio.Events.V1.SinkTestInstance>"
            end

            ##
            # Provide a detailed, user friendly representation
            def inspect
              "<Twilio.Events.V1.SinkTestInstance>"
            end
          end
        end
      end
    end
  end
end