##
# This code was generated by
# \ / _    _  _|   _  _
#  | (_)\/(_)(_|\/| |(/_  v1.0.0
#       /       /
#
# frozen_string_literal: true

module Twilio
  module REST
    class Events < Domain
      class V1 < Version
        class SinkContext < InstanceContext
          ##
          # PLEASE NOTE that this class contains beta products that are subject to change. Use them with caution.
          class SinkValidateList < ListResource
            ##
            # Initialize the SinkValidateList
            # @param [Version] version Version that contains the resource
            # @param [String] sid A 34 character string that uniquely identifies this Sink.
            # @return [SinkValidateList] SinkValidateList
            def initialize(version, sid: nil)
              super(version)

              # Path Solution
              @solution = {sid: sid}
              @uri = "/Sinks/#{@solution[:sid]}/Validate"
            end

            ##
            # Create the SinkValidateInstance
            # @param [String] test_id A 34 character string that uniquely identifies the test
            #   event for a Sink being validated.
            # @return [SinkValidateInstance] Created SinkValidateInstance
            def create(test_id: nil)
              data = Twilio::Values.of({'TestId' => test_id, })

              payload = @version.create('POST', @uri, data: data)

              SinkValidateInstance.new(@version, payload, sid: @solution[:sid], )
            end

            ##
            # Provide a user friendly representation
            def to_s
              '#<Twilio.Events.V1.SinkValidateList>'
            end
          end

          ##
          # PLEASE NOTE that this class contains beta products that are subject to change. Use them with caution.
          class SinkValidatePage < Page
            ##
            # Initialize the SinkValidatePage
            # @param [Version] version Version that contains the resource
            # @param [Response] response Response from the API
            # @param [Hash] solution Path solution for the resource
            # @return [SinkValidatePage] SinkValidatePage
            def initialize(version, response, solution)
              super(version, response)

              # Path Solution
              @solution = solution
            end

            ##
            # Build an instance of SinkValidateInstance
            # @param [Hash] payload Payload response from the API
            # @return [SinkValidateInstance] SinkValidateInstance
            def get_instance(payload)
              SinkValidateInstance.new(@version, payload, sid: @solution[:sid], )
            end

            ##
            # Provide a user friendly representation
            def to_s
              '<Twilio.Events.V1.SinkValidatePage>'
            end
          end

          ##
          # PLEASE NOTE that this class contains beta products that are subject to change. Use them with caution.
          class SinkValidateInstance < InstanceResource
            ##
            # Initialize the SinkValidateInstance
            # @param [Version] version Version that contains the resource
            # @param [Hash] payload payload that contains response from Twilio
            # @param [String] sid A 34 character string that uniquely identifies this Sink.
            # @return [SinkValidateInstance] SinkValidateInstance
            def initialize(version, payload, sid: nil)
              super(version)

              # Marshaled Properties
              @properties = {'result' => payload['result'], }
            end

            ##
            # @return [String] Feedback indicating whether the given Sink was validated.
            def result
              @properties['result']
            end

            ##
            # Provide a user friendly representation
            def to_s
              "<Twilio.Events.V1.SinkValidateInstance>"
            end

            ##
            # Provide a detailed, user friendly representation
            def inspect
              "<Twilio.Events.V1.SinkValidateInstance>"
            end
          end
        end
      end
    end
  end
end