##
# This code was generated by
# \ / _    _  _|   _  _
#  | (_)\/(_)(_|\/| |(/_  v1.0.0
#       /       /
#
# frozen_string_literal: true

module Twilio
  module REST
    class Lookups
      class V1 < Version
        ##
        # Initialize the V1 version of Lookups
        def initialize(domain)
          super
          @version = 'v1'
          @phone_numbers = nil
        end

        ##
        # @param [String] phone_number The phone number to lookup in
        #   {E.164}[https://www.twilio.com/docs/glossary/what-e164] format, which consists
        #   of a + followed by the country code and subscriber number.
        # @return [Twilio::REST::Lookups::V1::PhoneNumberContext] if phone_number was passed.
        # @return [Twilio::REST::Lookups::V1::PhoneNumberList]
        def phone_numbers(phone_number=:unset)
          if phone_number.nil?
              raise ArgumentError, 'phone_number cannot be nil'
          end
          if phone_number == :unset
              @phone_numbers ||= PhoneNumberList.new self
          else
              PhoneNumberContext.new(self, phone_number)
          end
        end

        ##
        # Provide a user friendly representation
        def to_s
          '<Twilio::REST::Lookups::V1>'
        end
      end
    end
  end
end