##
# This code was generated by
# \ / _    _  _|   _  _
#  | (_)\/(_)(_|\/| |(/_  v1.0.0
#       /       /
#
# frozen_string_literal: true

module Twilio
  module REST
    class Messaging
      class V1 < Version
        ##
        # Initialize the V1 version of Messaging
        def initialize(domain)
          super
          @version = 'v1'
          @brand_registrations = nil
          @deactivations = nil
          @external_campaign = nil
          @services = nil
          @usecases = nil
        end

        ##
        # @param [String] sid The SID of the Brand Registration resource to fetch.
        # @return [Twilio::REST::Messaging::V1::BrandRegistrationContext] if sid was passed.
        # @return [Twilio::REST::Messaging::V1::BrandRegistrationList]
        def brand_registrations(sid=:unset)
          if sid.nil?
              raise ArgumentError, 'sid cannot be nil'
          end
          if sid == :unset
              @brand_registrations ||= BrandRegistrationList.new self
          else
              BrandRegistrationContext.new(self, sid)
          end
        end

        ##
        # @return [Twilio::REST::Messaging::V1::DeactivationsContext]
        def deactivations
          @deactivations ||= DeactivationsContext.new self
        end

        ##
        # @return [Twilio::REST::Messaging::V1::ExternalCampaignContext]
        def external_campaign
          @external_campaign ||= ExternalCampaignList.new self
        end

        ##
        # @param [String] sid The SID of the Service resource to fetch.
        # @return [Twilio::REST::Messaging::V1::ServiceContext] if sid was passed.
        # @return [Twilio::REST::Messaging::V1::ServiceList]
        def services(sid=:unset)
          if sid.nil?
              raise ArgumentError, 'sid cannot be nil'
          end
          if sid == :unset
              @services ||= ServiceList.new self
          else
              ServiceContext.new(self, sid)
          end
        end

        ##
        # @return [Twilio::REST::Messaging::V1::UsecaseContext]
        def usecases
          @usecases ||= UsecaseList.new self
        end

        ##
        # Provide a user friendly representation
        def to_s
          '<Twilio::REST::Messaging::V1>'
        end
      end
    end
  end
end