##
# This code was generated by
# \ / _    _  _|   _  _
#  | (_)\/(_)(_|\/| |(/_  v1.0.0
#       /       /
#
# frozen_string_literal: true

module Twilio
  module REST
    class Messaging < Domain
      class V1 < Version
        ##
        # PLEASE NOTE that this class contains beta products that are subject to change. Use them with caution.
        class UsecaseList < ListResource
          ##
          # Initialize the UsecaseList
          # @param [Version] version Version that contains the resource
          # @return [UsecaseList] UsecaseList
          def initialize(version)
            super(version)

            # Path Solution
            @solution = {}
            @uri = "/Services/Usecases"
          end

          ##
          # Fetch the UsecaseInstance
          # @return [UsecaseInstance] Fetched UsecaseInstance
          def fetch
            payload = @version.fetch('GET', @uri)

            UsecaseInstance.new(@version, payload, )
          end

          ##
          # Provide a user friendly representation
          def to_s
            '#<Twilio.Messaging.V1.UsecaseList>'
          end
        end

        ##
        # PLEASE NOTE that this class contains beta products that are subject to change. Use them with caution.
        class UsecasePage < Page
          ##
          # Initialize the UsecasePage
          # @param [Version] version Version that contains the resource
          # @param [Response] response Response from the API
          # @param [Hash] solution Path solution for the resource
          # @return [UsecasePage] UsecasePage
          def initialize(version, response, solution)
            super(version, response)

            # Path Solution
            @solution = solution
          end

          ##
          # Build an instance of UsecaseInstance
          # @param [Hash] payload Payload response from the API
          # @return [UsecaseInstance] UsecaseInstance
          def get_instance(payload)
            UsecaseInstance.new(@version, payload, )
          end

          ##
          # Provide a user friendly representation
          def to_s
            '<Twilio.Messaging.V1.UsecasePage>'
          end
        end

        ##
        # PLEASE NOTE that this class contains beta products that are subject to change. Use them with caution.
        class UsecaseInstance < InstanceResource
          ##
          # Initialize the UsecaseInstance
          # @param [Version] version Version that contains the resource
          # @param [Hash] payload payload that contains response from Twilio
          # @return [UsecaseInstance] UsecaseInstance
          def initialize(version, payload)
            super(version)

            # Marshaled Properties
            @properties = {'usecases' => payload['usecases'], }
          end

          ##
          # @return [Array[Hash]] Human readable Messaging Service Use Case details
          def usecases
            @properties['usecases']
          end

          ##
          # Provide a user friendly representation
          def to_s
            "<Twilio.Messaging.V1.UsecaseInstance>"
          end

          ##
          # Provide a detailed, user friendly representation
          def inspect
            "<Twilio.Messaging.V1.UsecaseInstance>"
          end
        end
      end
    end
  end
end