##
# This code was generated by
# \ / _    _  _|   _  _
#  | (_)\/(_)(_|\/| |(/_  v1.0.0
#       /       /
#
# frozen_string_literal: true

module Twilio
  module REST
    class Notify < Domain
      ##
      # Initialize the Notify Domain
      def initialize(twilio)
        super

        @base_url = 'https://notify.twilio.com'
        @host = 'notify.twilio.com'
        @port = 443

        # Versions
        @v1 = nil
      end

      ##
      # Version v1 of notify
      def v1
        @v1 ||= V1.new self
      end

      ##
      # @param [String] sid The unique string that we created to identify the Credential
      #   resource.
      # @return [Twilio::REST::Notify::V1::CredentialInstance] if sid was passed.
      # @return [Twilio::REST::Notify::V1::CredentialList]
      def credentials(sid=:unset)
        self.v1.credentials(sid)
      end

      ##
      # @param [String] sid The unique string that we created to identify the Service
      #   resource.
      # @return [Twilio::REST::Notify::V1::ServiceInstance] if sid was passed.
      # @return [Twilio::REST::Notify::V1::ServiceList]
      def services(sid=:unset)
        self.v1.services(sid)
      end

      ##
      # Provide a user friendly representation
      def to_s
        '#<Twilio::REST::Notify>'
      end
    end
  end
end