##
# This code was generated by
# \ / _    _  _|   _  _
#  | (_)\/(_)(_|\/| |(/_  v1.0.0
#       /       /
#
# frozen_string_literal: true

module Twilio
  module REST
    class Preview
      class TrustedComms < Version
        ##
        # Initialize the TrustedComms version of Preview
        def initialize(domain)
          super
          @version = 'TrustedComms'
          @branded_channels = nil
          @brands_information = nil
          @cps = nil
          @current_calls = nil
        end

        ##
        # @param [String] sid The unique SID identifier of the Branded Channel.
        # @return [Twilio::REST::Preview::TrustedComms::BrandedChannelContext] if sid was passed.
        # @return [Twilio::REST::Preview::TrustedComms::BrandedChannelList]
        def branded_channels(sid=:unset)
          if sid.nil?
              raise ArgumentError, 'sid cannot be nil'
          end
          if sid == :unset
              @branded_channels ||= BrandedChannelList.new self
          else
              BrandedChannelContext.new(self, sid)
          end
        end

        ##
        # @return [Twilio::REST::Preview::TrustedComms::BrandsInformationContext]
        def brands_information
          @brands_information ||= BrandsInformationContext.new self
        end

        ##
        # @return [Twilio::REST::Preview::TrustedComms::CpsContext]
        def cps
          @cps ||= CpsContext.new self
        end

        ##
        # @return [Twilio::REST::Preview::TrustedComms::CurrentCallContext]
        def current_calls
          @current_calls ||= CurrentCallContext.new self
        end

        ##
        # Provide a user friendly representation
        def to_s
          '<Twilio::REST::Preview::TrustedComms>'
        end
      end
    end
  end
end