##
# This code was generated by
# \ / _    _  _|   _  _
#  | (_)\/(_)(_|\/| |(/_  v1.0.0
#       /       /
#
# frozen_string_literal: true

module Twilio
  module REST
    class Preview
      class Understand < Version
        ##
        # Initialize the Understand version of Preview
        def initialize(domain)
          super
          @version = 'understand'
          @assistants = nil
        end

        ##
        # @param [String] sid A 34 character string that uniquely identifies this
        #   resource.
        # @return [Twilio::REST::Preview::Understand::AssistantContext] if sid was passed.
        # @return [Twilio::REST::Preview::Understand::AssistantList]
        def assistants(sid=:unset)
          if sid.nil?
              raise ArgumentError, 'sid cannot be nil'
          end
          if sid == :unset
              @assistants ||= AssistantList.new self
          else
              AssistantContext.new(self, sid)
          end
        end

        ##
        # Provide a user friendly representation
        def to_s
          '<Twilio::REST::Preview::Understand>'
        end
      end
    end
  end
end