##
# This code was generated by
# \ / _    _  _|   _  _
#  | (_)\/(_)(_|\/| |(/_  v1.0.0
#       /       /
#
# frozen_string_literal: true

module Twilio
  module REST
    class Studio < Domain
      ##
      # Initialize the Studio Domain
      def initialize(twilio)
        super

        @base_url = 'https://studio.twilio.com'
        @host = 'studio.twilio.com'
        @port = 443

        # Versions
        @v1 = nil
        @v2 = nil
      end

      ##
      # Version v1 of studio
      def v1
        @v1 ||= V1.new self
      end

      ##
      # Version v2 of studio
      def v2
        @v2 ||= V2.new self
      end

      ##
      # @param [String] sid The unique string that we created to identify the Flow
      #   resource.
      # @return [Twilio::REST::Studio::V2::FlowInstance] if sid was passed.
      # @return [Twilio::REST::Studio::V2::FlowList]
      def flows(sid=:unset)
        self.v2.flows(sid)
      end

      ##
      # @return [Twilio::REST::Studio::V2::FlowValidateInstance]
      def flow_validate
        self.v2.flow_validate()
      end

      ##
      # Provide a user friendly representation
      def to_s
        '#<Twilio::REST::Studio>'
      end
    end
  end
end