##
# This code was generated by
# \ / _    _  _|   _  _
#  | (_)\/(_)(_|\/| |(/_  v1.0.0
#       /       /
#
# frozen_string_literal: true

module Twilio
  module REST
    class Studio
      class V2 < Version
        ##
        # Initialize the V2 version of Studio
        def initialize(domain)
          super
          @version = 'v2'
          @flows = nil
          @flow_validate = nil
        end

        ##
        # @param [String] sid The SID of the Flow resource to fetch.
        # @return [Twilio::REST::Studio::V2::FlowContext] if sid was passed.
        # @return [Twilio::REST::Studio::V2::FlowList]
        def flows(sid=:unset)
          if sid.nil?
              raise ArgumentError, 'sid cannot be nil'
          end
          if sid == :unset
              @flows ||= FlowList.new self
          else
              FlowContext.new(self, sid)
          end
        end

        ##
        # @return [Twilio::REST::Studio::V2::FlowValidateContext]
        def flow_validate
          @flow_validate ||= FlowValidateList.new self
        end

        ##
        # Provide a user friendly representation
        def to_s
          '<Twilio::REST::Studio::V2>'
        end
      end
    end
  end
end