##
# This code was generated by
# \ / _    _  _|   _  _
#  | (_)\/(_)(_|\/| |(/_  v1.0.0
#       /       /
#
# frozen_string_literal: true

module Twilio
  module REST
    class Trusthub < Domain
      ##
      # Initialize the Trusthub Domain
      def initialize(twilio)
        super

        @base_url = 'https://trusthub.twilio.com'
        @host = 'trusthub.twilio.com'
        @port = 443

        # Versions
        @v1 = nil
      end

      ##
      # Version v1 of trusthub
      def v1
        @v1 ||= V1.new self
      end

      ##
      # @param [String] sid The unique string that we created to identify the
      #   Customer-Profile resource.
      # @return [Twilio::REST::Trusthub::V1::CustomerProfilesInstance] if sid was passed.
      # @return [Twilio::REST::Trusthub::V1::CustomerProfilesList]
      def customer_profiles(sid=:unset)
        self.v1.customer_profiles(sid)
      end

      ##
      # @param [String] sid The unique string created by Twilio to identify the End User
      #   resource.
      # @return [Twilio::REST::Trusthub::V1::EndUserInstance] if sid was passed.
      # @return [Twilio::REST::Trusthub::V1::EndUserList]
      def end_users(sid=:unset)
        self.v1.end_users(sid)
      end

      ##
      # @param [String] sid The unique string that identifies the End-User Type
      #   resource.
      # @return [Twilio::REST::Trusthub::V1::EndUserTypeInstance] if sid was passed.
      # @return [Twilio::REST::Trusthub::V1::EndUserTypeList]
      def end_user_types(sid=:unset)
        self.v1.end_user_types(sid)
      end

      ##
      # @param [String] sid The unique string that identifies the Policy resource.
      # @return [Twilio::REST::Trusthub::V1::PoliciesInstance] if sid was passed.
      # @return [Twilio::REST::Trusthub::V1::PoliciesList]
      def policies(sid=:unset)
        self.v1.policies(sid)
      end

      ##
      # @param [String] sid The unique string created by Twilio to identify the
      #   Supporting Document resource.
      # @return [Twilio::REST::Trusthub::V1::SupportingDocumentInstance] if sid was passed.
      # @return [Twilio::REST::Trusthub::V1::SupportingDocumentList]
      def supporting_documents(sid=:unset)
        self.v1.supporting_documents(sid)
      end

      ##
      # @param [String] sid The unique string that identifies the Supporting Document
      #   Type resource.
      # @return [Twilio::REST::Trusthub::V1::SupportingDocumentTypeInstance] if sid was passed.
      # @return [Twilio::REST::Trusthub::V1::SupportingDocumentTypeList]
      def supporting_document_types(sid=:unset)
        self.v1.supporting_document_types(sid)
      end

      ##
      # @param [String] sid The unique string that we created to identify the
      #   Customer-Profile resource.
      # @return [Twilio::REST::Trusthub::V1::TrustProductsInstance] if sid was passed.
      # @return [Twilio::REST::Trusthub::V1::TrustProductsList]
      def trust_products(sid=:unset)
        self.v1.trust_products(sid)
      end

      ##
      # Provide a user friendly representation
      def to_s
        '#<Twilio::REST::Trusthub>'
      end
    end
  end
end