##
# This code was generated by
# \ / _    _  _|   _  _
#  | (_)\/(_)(_|\/| |(/_  v1.0.0
#       /       /
#
# frozen_string_literal: true

module Twilio
  module REST
    class Verify < Domain
      ##
      # Initialize the Verify Domain
      def initialize(twilio)
        super

        @base_url = 'https://verify.twilio.com'
        @host = 'verify.twilio.com'
        @port = 443

        # Versions
        @v2 = nil
      end

      ##
      # Version v2 of verify
      def v2
        @v2 ||= V2.new self
      end

      ##
      # @param [form.FormTypes] form_type The Type of this Form. Currently only
      #   `form-push` is supported.
      # @return [Twilio::REST::Verify::V2::FormInstance] if form_type was passed.
      # @return [Twilio::REST::Verify::V2::FormList]
      def forms(form_type=:unset)
        self.v2.forms(form_type)
      end

      ##
      # @param [String] sid The unique string that we created to identify the Service
      #   resource.
      # @return [Twilio::REST::Verify::V2::ServiceInstance] if sid was passed.
      # @return [Twilio::REST::Verify::V2::ServiceList]
      def services(sid=:unset)
        self.v2.services(sid)
      end

      ##
      # @param [String] sid A 34 character string that uniquely identifies this
      #   Verification Attempt.
      # @return [Twilio::REST::Verify::V2::VerificationAttemptInstance] if sid was passed.
      # @return [Twilio::REST::Verify::V2::VerificationAttemptList]
      def verification_attempts(sid=:unset)
        self.v2.verification_attempts(sid)
      end

      ##
      # @return [Twilio::REST::Verify::V2::VerificationTemplateInstance]
      def verification_templates
        self.v2.verification_templates()
      end

      ##
      # Provide a user friendly representation
      def to_s
        '#<Twilio::REST::Verify>'
      end
    end
  end
end